# Copyright (c) 2016-2018 Braintech Sp. z o.o. [Ltd.] <http://www.braintech.pl>
# All rights reserved.

import sys

from setuptools import find_namespace_packages, setup

PYTHON_V = sys.version_info[0]
INSTALL_REQUIREMENTS = {
    'install': [
        'numpy',
        'braintech-utils~=2.8.0',
        'pyserial==3.4',
        'six',
        'PySide2',
    ],
    'codestyle': [
        'flake8~=3.0.4',
        'pylint~=1.7.2',
    ],
    'test': [
        'pytest~=3.1.2',
        'pytest-cov~=2.5.1',
        'pytest-qt~=2.4.1',
        'pytest-timeout~=1.2.0',
        'nose~=1.3.7',
    ],
    'build': ['stdeb>=0.8.5', 'wheel>=0.29.0'],
    'dev': ['check-manifest>=0.34', 'versioneer==0.17'],
}

if PYTHON_V == 2:
    INSTALL_REQUIREMENTS['install'].extend(['enum34', 'future'])
SETUP_REQUIREMENTS = []
if __name__ == '__main__':
    import versioneer

    setup(
        name='braintech-drivers-blinker',
        version=versioneer.get_version(),
        cmdclass=versioneer.get_cmdclass(),
        zip_safe=False,
        author='BrainTech',
        author_email='admin@braintech.pl',
        description='Drivers for Braintech Blinker display.',
        packages=find_namespace_packages(include=['braintech.drivers.*']),
        include_package_data=True,
        exclude_package_data={'': ['.gitignore', '.gitlab-ci.yml']},
        install_requires=INSTALL_REQUIREMENTS['install'],
        setup_requires=SETUP_REQUIREMENTS,
        extras_require=INSTALL_REQUIREMENTS,
        entry_points={} if PYTHON_V == 2 else {  # Assume that it will be installed by python3 package
            'console_scripts': [
                'install_blinker = braintech.drivers.blinker.install:run'
            ]
        }
    )
