#!/usr/bin/env python3
# Copyright (c) 2016-2018 Braintech Sp. z o.o. [Ltd.] <http://www.braintech.pl>
# All rights reserved.

from braintech.obci.signal_processing.signal import info_file_proxy as p


def test_info_file_proxy(tmpdir):
    f_name = str(tmpdir.join('./tescik.obci.svarog.info'))
    px = p.InfoFileWriteProxy(f_name)

    px.set_attributes({'number_of_channels': 2, 'sampling_frequency': 128, 'channels_names': ['1', '2'],
                       'video_file_name': 'film.mp4', 'video_file_offset': 3.5,
                       'file': 'soufce.obci.dat', 'number_of_samples': 3
                       })
    assert px.save_info() == f_name
    py = p.InfoFileReadProxy(f_name)

    assert py.get_param('number_of_channels') == '2'

    assert py.get_param('channels_names')[0] == '1'

    assert py.get_param('video_file_name') == 'film.mp4'

    assert py.get_param('video_file_offset') == '3.5'
