# Copyright (c) 2016-2018 Braintech Sp. z o.o. [Ltd.] <http://www.braintech.pl>
# All rights reserved
import bz2
import sys
import urllib.request
from pathlib import Path

from bci_artifacts import camera

TRAINED_FACE_SHAPE_PREDICTOR_PATH = Path(camera.__file__).parent / 'shape_predictor_68_face_landmarks.dat'


def download_face_predictor():
    trained_model_url = 'http://dlib.net/files/shape_predictor_68_face_landmarks.dat.bz2'
    destination_path = TRAINED_FACE_SHAPE_PREDICTOR_PATH
    if destination_path.exists():
        print("face predictor already downloaded")
        return
    print("Downloading face predictor to:", str(destination_path))
    if '--dry-run' in sys.argv:
        return
    temp_tar_path, _ = urllib.request.urlretrieve(trained_model_url)
    with bz2.open(temp_tar_path, mode='rb') as compressed:
        with destination_path.open(mode='wb') as destination:
            destination.write(compressed.read())


APT_REQUIREMENTS = [
    'cmake',
]


def run():
    from braintech.utils.install import install_apt_requirements
    install_apt_requirements(APT_REQUIREMENTS, "bci-artifacts")
