import P300Blinker from 'obci_bci_demo/../p300'
import _ from 'lodash'

class SSVEPBlinker extends P300Blinker
  constructor: ->
    super arguments...
    @on 'update_fields', _.debounce(@_update_fields, 100, leading: true)

  _setInstruction: (text) =>
    super(text)
    @_define_field(@instruction[0], @fields.length)

  setChannel: (frontend) =>
    super(frontend)

  _update_fields: (data) =>
    fields = {}
    fields[@fields.length] = @instruction[0]
    fields[i] = f for f,i in @fields

    @_define_fields(fields)

  _define_field: (el, field_id) ->
    fields = {}
    fields[field_id] = el
    @_define_fields(fields)

  _define_fields: (fields) ->
    w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    h = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    field_sizes = {}
    for field_id,f of fields
      client_rect = f.getBoundingClientRect()
      field_sizes[field_id] =
        x: client_rect.x / w
        y: client_rect.y / h
        width: client_rect.width / w
        height: client_rect.height / h
    @frontend.set_field_sizes(field_sizes)

export default SSVEPBlinker
