import c3 from 'c3'
import {redraw_chart_on_resize} from './charts'


initializeFeatures = (socket) ->
  chart = c3.generate
    bindto: 'features'
    data:
      columns: []
      x: 'x'
      type: 'bar'
    legend:
      show: false
    tooltip:
      show: false
    axis:
      y:
        label:
          text: 'power'
          position: 'outer-top'
      x:
        label:
          text: 'frequency [Hz]'
          position: 'outer-right'

  bind_to_socket(socket, chart)
  redraw_chart_on_resize(chart)



bind_to_socket = (socket, chart) ->
  socket.on 'features', (data) ->
    columns = [
      ['x'].concat(data.x),
      ['features'].concat(data.y),
    ]
    chart.load
      columns: columns


export default initializeFeatures
