
bindActivatorsToSockets = (socket) ->
  socket.on 'erp', (data) ->
    if data.calibration
      activate_calibration_session()
    else
      activate_online_session()
    $('#erp').addClass('visible').removeClass('hidden')
  socket.on 'certainty_histogram', ->
    activate_calibration_session()
    $('#certainty-histogram').addClass('visible').removeClass('hidden')
  socket.on 'classifier_certainty', ->
    activate_online_session()
    $('#classifier-certainty').addClass('visible').removeClass('hidden')
  socket.on 'AUC', ->
    activate_calibration_session()
    $('#quality-summary, #auc').addClass('visible').removeClass('hidden')
  socket.on 'mean_example_count', ->
    activate_calibration_session()
    $('#quality-summary, #mean_example_count').addClass('visible').removeClass('hidden')
  socket.on 'best_freqs', ->
    activate_calibration_session()
    $('#quality-summary, #best_freqs').addClass('visible').removeClass('hidden')
  socket.on 'ITR', ->
    activate_online_session()
    $('#quality-summary, #itr').addClass('visible').removeClass('hidden')
  socket.on 'ACC', ->
    activate_online_session()
    $('#quality-summary, #acc').addClass('visible').removeClass('hidden')
  socket.on 'features', ->
    $('#features').addClass('visible').removeClass('hidden')
    activate_calibration_session()
  socket.on 'frequency_preference_function', ->
    $('#frequency_preference_function').addClass('visible').removeClass('hidden')
    activate_calibration_session()


activate_calibration_session = ->
  session_name = 'calibration'
  if $('#charts').data('session') != session_name
    $('#charts').data('session', session_name)
    _hide_noncalibration_elements()


activate_online_session = ->
  session_name = 'online'
  if $('#charts').data('session') != session_name
    $('#charts').data('session', session_name)
    _hide_nononline_elements()


_hide_noncalibration_elements = ->
  $('#classifier-certainty, #itr, #acc').addClass('hidden').removeClass('visible')


_hide_nononline_elements = ->
  $('#certainty-histogram, #features, #auc').addClass('hidden').removeClass('visible')

export default bindActivatorsToSockets
