# Copyright (c) 2016-2018 Braintech Sp. z o.o. [Ltd.] <http://www.braintech.pl>
# All rights reserved
from pathlib import Path

import versioneer
from setuptools import find_packages, setup

INSTALL_REQUIREMENTS = {
    'install': [
        'braintech-obci-core',
        'obci_ugm',
        'obci-p300',
        'bci-panel',
        'scipy',
        'numpy',
        'matplotlib',
        'scikit-image~=0.13.1',
        'braintech-drivers-blinker>=3.1.0',
    ],
    'setup': [
        'setuptools_scm'
    ]
}

if __name__ == '__main__':
    setup(
        name='bci-ssvep',
        cmdclass={},
        zip_safe=False,
        author='BrainTech',
        author_email='admin@braintech.pl',
        description='BCI SSVEP.',
        version=versioneer.get_version(),
        packages=find_packages(
            exclude=[
                'test',
                'scripts',
            ]
        ),
        include_package_data=True,
        install_requires=INSTALL_REQUIREMENTS['install'],
        setup_requires=INSTALL_REQUIREMENTS['setup'],
        extras_require=INSTALL_REQUIREMENTS,
        entry_points={
            'console_scripts': [
            ]
        }
    )
