# Copyright (c) 2016-2018 Braintech Sp. z o.o. [Ltd.] <http://www.braintech.pl>
# All rights reserved
import numpy as np

from obci_p300.helper_functions import get_montage_matrix_csa, get_montage_matrix_ears, get_montage_matrix_custom


def test_get_montage_matrix_csan():
    matrix = get_montage_matrix_csa(5)
    assert np.array_equal(matrix, np.array([[1., -0.25, -0.25, -0.25, -0.25],
                                            [-0.25, 1., -0.25, -0.25, -0.25],
                                            [-0.25, -0.25, 1., -0.25, -0.25],
                                            [-0.25, -0.25, -0.25, 1., -0.25],
                                            [-0.25, -0.25, -0.25, -0.25, 1.]]))


def test_get_montage_matrix_ears():
    matrix = get_montage_matrix_ears(5, 2, 4)
    assert np.array_equal(matrix, np.array([[1., 0., -0.5, 0., -0.5],
                                            [0., 1., -0.5, 0., -0.5],
                                            [0., 0., 1., 0., 0.],
                                            [0., 0., -0.5, 1., -0.5],
                                            [0., 0., 0., 0., 1.]]))


def test_get_montage_matrix_custom():
    matrix = get_montage_matrix_custom(5, [2, 4])
    assert np.array_equal(matrix, np.array([[1., 0., -0.5, 0., -0.5],
                                            [0., 1., -0.5, 0., -0.5],
                                            [0., 0., 1., 0., 0.],
                                            [0., 0., -0.5, 1., -0.5],
                                            [0., 0., 0., 0., 1.]]))
